// 导入组件
import PCodeGit from "./PCodeGit"
import PPlantUML from "./PPlantUML"
import PTableDesign from "./PTableDesign"

// 存储组件列表
const Components = [
    PCodeGit,
    PPlantUML,
    PTableDesign
]

// 定义 install 方法，接收 Vue 作为参数。如果使用 use 注册插件，则所有的组件都将被注册
const install = function (Vue) {
    // 判断是否安装
    if (install.installed) {
        return
    }
    // 遍历注册全局组件
    Components.map(component => Vue.component(component.name, component));
}

/* 支持使用标签的方式引入 */
if (typeof window !== 'undefined' && window.Vue) {
    install(window.Vue);
}

Components.install = install;

export default Components;